package xyz.ibatv.nethercraft.block;

// REMOVE "BARRELS" FOR ACTUAL CHESTS AT SOME POINT.

import xyz.ibatv.nethercraft.block.entity.MoreBarrelBlockEntity;
import net.minecraft.block.BarrelBlock;
import net.minecraft.block.BlockState;
import net.minecraft.block.Blocks;
import net.minecraft.block.MapColor;
import net.minecraft.block.entity.BlockEntity;
import net.minecraft.entity.mob.PiglinBrain;
import net.minecraft.entity.player.PlayerEntity;
import net.minecraft.server.world.ServerWorld;
import net.minecraft.sound.BlockSoundGroup;
import net.minecraft.stat.Stats;
import net.minecraft.util.ActionResult;
import net.minecraft.util.hit.BlockHitResult;
import net.minecraft.util.math.BlockPos;
import net.minecraft.util.math.random.Random;
import net.minecraft.world.World;
import org.jetbrains.annotations.NotNull;

public class MoreBarrelBlock extends BarrelBlock {
    public final String barrelWoodType;

    public MoreBarrelBlock(MapColor colour, String barrelWoodType) {
        super(Settings.copy(Blocks.BARREL).mapColor(colour));
        this.barrelWoodType = barrelWoodType;
    }

    public MoreBarrelBlock(MapColor colour, BlockSoundGroup soundType, String barrelWoodType) {
        super(Settings.copy(Blocks.BARREL).mapColor(colour).sounds(soundType));
        this.barrelWoodType = barrelWoodType;
    }

    @Override
    protected @NotNull ActionResult onUse(BlockState state, World level, BlockPos pos, PlayerEntity player, BlockHitResult hitResult) {
        if (level.isClient) {
            return ActionResult.SUCCESS;
        } else {
            BlockEntity blockEntity = level.getBlockEntity(pos);
            if (blockEntity instanceof MoreBarrelBlockEntity) {
                player.openHandledScreen((MoreBarrelBlockEntity)blockEntity);
                player.incrementStat(Stats.OPEN_BARREL);
                PiglinBrain.onGuardedBlockInteracted(player, true);
            }

            return ActionResult.CONSUME;
        }
    }

    @Override
    protected void scheduledTick(BlockState state, ServerWorld level, BlockPos pos, Random random) {
        BlockEntity blockEntity = level.getBlockEntity(pos);
        if (blockEntity instanceof MoreBarrelBlockEntity) {
            ((MoreBarrelBlockEntity)blockEntity).recheckOpen();
        }

    }

    @Override
    public BlockEntity createBlockEntity(BlockPos pos, BlockState state) {
        return new MoreBarrelBlockEntity(pos, state);
    }
}