package xyz.ibatv.nethercraft.block.custom;


import com.google.common.collect.Maps;
import java.util.Map;

import net.minecraft.block.*;
import net.minecraft.item.BlockItem;
import net.minecraft.item.Item;
import net.minecraft.registry.Registry;
import net.minecraft.sound.BlockSoundGroup;
import net.minecraft.block.enums.NoteBlockInstrument;
import net.minecraft.util.Identifier;
import net.minecraft.registry.Registries;

public class MoreCraftingTableBlock {
    public static final CraftingTableBlock GLOWOOD_CRAFTING_TABLE;
    public static Map<Identifier, Block> VANILLA_CRAFTING_TABLES;

    public MoreCraftingTableBlock() {
    }

    public static void registerTables() {
        registerCraftingTableBlock("glowood_crafting_table", GLOWOOD_CRAFTING_TABLE);
    }

    private static void registerCraftingTableBlock(String name, Block block) {
        Identifier identifier = Identifier.of("nethercraft-classic", name);
        Registry.register(Registries.BLOCK, identifier, block);
        VANILLA_CRAFTING_TABLES.put(identifier, block);
        Registry.register(Registries.ITEM, identifier, new BlockItem(block, new Item.Settings()));
    }

    static {
            GLOWOOD_CRAFTING_TABLE = new CraftingTableBlock(AbstractBlock.Settings.copy(Blocks.CRAFTING_TABLE).mapColor(MapColor.DARK_AQUA).instrument(NoteBlockInstrument.BASS).strength(2.5F).sounds(BlockSoundGroup.WOOD));
        VANILLA_CRAFTING_TABLES = Maps.newHashMap();
    }
}
