package xyz.ibatv.nethercraft.datagen;

import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricTagProvider;
import net.minecraft.registry.RegistryWrapper;
import net.minecraft.registry.tag.BlockTags;
import xyz.ibatv.nethercraft.block.ModBlocks;

import java.util.concurrent.CompletableFuture;

public class ModBlockTagProvider extends FabricTagProvider.BlockTagProvider {
    public ModBlockTagProvider(FabricDataOutput output, CompletableFuture<RegistryWrapper.WrapperLookup> registriesFuture) {
        super(output, registriesFuture);
    }

    @Override
    protected void configure(RegistryWrapper.WrapperLookup wrapperLookup) {
        getOrCreateTagBuilder(BlockTags.AXE_MINEABLE)
                .add(ModBlocks.GLOWOOD_PLANKS)
                .add(ModBlocks.GLOWOOD_LOG)
                .add(ModBlocks.GLOWOOD_BOOKSHELF)
                .add(ModBlocks.GLOWOOD_STAIRS)
                .add(ModBlocks.GLOWOOD_PRESSUREPLATE)
                .add(ModBlocks.GLOWOOD_FENCE)
                .add(ModBlocks.GLOWOOD_DOOR)
                .add(ModBlocks.GLOWOOD_LADDER);

        getOrCreateTagBuilder(BlockTags.PICKAXE_MINEABLE)
                .add(ModBlocks.SMOOTH_NETHERRACK)
                .add(ModBlocks.FOULITE_ORE)
                .add(ModBlocks.NERIDIUM_ORE)
                .add(ModBlocks.PYRIDIUM_ORE)
                .add(ModBlocks.LINIUM_ORE)
                .add(ModBlocks.W_ORE)
                .add(ModBlocks.NERIDIUM_BLOCK)
                .add(ModBlocks.PYRIDIUM_BLOCK)
                .add(ModBlocks.LINIUM_BLOCK);

        getOrCreateTagBuilder(BlockTags.SHOVEL_MINEABLE)
                .add(ModBlocks.NETHER_DIRT)
                .add(ModBlocks.HEAT_SAND);

        getOrCreateTagBuilder(BlockTags.NEEDS_STONE_TOOL);

        getOrCreateTagBuilder(BlockTags.NEEDS_IRON_TOOL);

        getOrCreateTagBuilder(BlockTags.NEEDS_DIAMOND_TOOL)
                .add(ModBlocks.PYRIDIUM_ORE);


        getOrCreateTagBuilder(BlockTags.LOGS)
                .add(ModBlocks.GLOWOOD_LOG);

        getOrCreateTagBuilder(BlockTags.LEAVES)
                .add(ModBlocks.GLOWOOD_LEAVES);

        getOrCreateTagBuilder(BlockTags.PLANKS)
                .add(ModBlocks.GLOWOOD_PLANKS);

        getOrCreateTagBuilder(BlockTags.ENCHANTMENT_POWER_PROVIDER)
                .add(ModBlocks.GLOWOOD_BOOKSHELF);

        getOrCreateTagBuilder(BlockTags.CROPS)
                .add(ModBlocks.DARK_WHEAT_CROP);

        getOrCreateTagBuilder(BlockTags.MAINTAINS_FARMLAND)
                .add(ModBlocks.DARK_WHEAT_CROP);

        getOrCreateTagBuilder(BlockTags.WOODEN_FENCES)
                .add(ModBlocks.GLOWOOD_FENCE);

        getOrCreateTagBuilder(BlockTags.CLIMBABLE)
                .add(ModBlocks.GLOWOOD_LADDER);

        getOrCreateTagBuilder(BlockTags.SAND)
                .add(ModBlocks.HEAT_SAND);

        getOrCreateTagBuilder(BlockTags.DIRT)
                .add(ModBlocks.NETHER_DIRT);

        getOrCreateTagBuilder(BlockTags.WOODEN_DOORS)
                .add(ModBlocks.GLOWOOD_DOOR);

        getOrCreateTagBuilder(BlockTags.WOODEN_STAIRS)
                .add(ModBlocks.GLOWOOD_STAIRS);

        getOrCreateTagBuilder(BlockTags.WOODEN_PRESSURE_PLATES)
                .add(ModBlocks.GLOWOOD_PRESSUREPLATE);

    }
}
