package xyz.ibatv.nethercraft.datagen;


import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricTagProvider;
import net.minecraft.registry.tag.ItemTags;
import xyz.ibatv.nethercraft.block.ModBlocks;
import xyz.ibatv.nethercraft.item.ModItems;
//import xyz.ibatv.nethercraft.util.ModTags;
import net.minecraft.item.Items;
import net.minecraft.registry.RegistryWrapper;

import java.util.concurrent.CompletableFuture;

public class ModItemTagProvider extends FabricTagProvider.ItemTagProvider {
    public ModItemTagProvider(FabricDataOutput output, CompletableFuture<RegistryWrapper.WrapperLookup> completableFuture) {
        super(output, completableFuture);
    }

    @Override
    protected void configure(RegistryWrapper.WrapperLookup wrapperLookup) {

        getOrCreateTagBuilder(ItemTags.LOGS)
                .add(ModBlocks.GLOWOOD_LOG.asItem());

        getOrCreateTagBuilder(ItemTags.PLANKS)
                .add(ModBlocks.GLOWOOD_PLANKS.asItem());

        getOrCreateTagBuilder(ItemTags.LEAVES)
                .add(ModBlocks.GLOWOOD_LEAVES.asItem());

        getOrCreateTagBuilder(ItemTags.SWORDS)
                .add(ModItems.GLOWOOD_SWORD)
                .add(ModItems.NETHER_SWORD)
                .add(ModItems.LINIUM_SWORD)
                .add(ModItems.NERIDIUM_SWORD)
                .add(ModItems.PYRIDIUM_SWORD);

        getOrCreateTagBuilder(ItemTags.PICKAXES)
                .add(ModItems.GLOWOOD_PICKAXE)
                .add(ModItems.NETHER_PICKAXE)
                .add(ModItems.LINIUM_PICKAXE)
                .add(ModItems.NERIDIUM_PICKAXE)
                .add(ModItems.PYRIDIUM_PICKAXE);

        getOrCreateTagBuilder(ItemTags.AXES)
                .add(ModItems.GLOWOOD_AXE)
                .add(ModItems.NETHER_AXE)
                .add(ModItems.LINIUM_AXE)
                .add(ModItems.NERIDIUM_AXE)
                .add(ModItems.PYRIDIUM_AXE);

        getOrCreateTagBuilder(ItemTags.SHOVELS)
                .add(ModItems.GLOWOOD_SHOVEL)
                .add(ModItems.NETHER_SHOVEL)
                .add(ModItems.LINIUM_SHOVEL)
                .add(ModItems.NERIDIUM_SHOVEL)
                .add(ModItems.PYRIDIUM_SHOVEL);

        getOrCreateTagBuilder(ItemTags.HOES)
                .add(ModItems.GLOWOOD_HOE)
                .add(ModItems.NETHER_HOE)
                .add(ModItems.LINIUM_HOE)
                .add(ModItems.NERIDIUM_HOE)
                .add(ModItems.PYRIDIUM_HOE);
    }
}
