package xyz.ibatv.nethercraft.datagen;

import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricBlockLootTableProvider;
import net.minecraft.block.Block;
import net.minecraft.enchantment.Enchantment;
import net.minecraft.enchantment.Enchantments;
import net.minecraft.item.Item;
import net.minecraft.item.Items;
import net.minecraft.loot.LootTable;
import net.minecraft.loot.condition.BlockStatePropertyLootCondition;
import net.minecraft.loot.entry.ItemEntry;
import net.minecraft.loot.entry.LeafEntry;
import net.minecraft.loot.entry.LootPoolEntry;
import net.minecraft.loot.function.ApplyBonusLootFunction;
import net.minecraft.loot.function.SetCountLootFunction;
import net.minecraft.loot.provider.number.UniformLootNumberProvider;
import net.minecraft.predicate.StatePredicate;
import net.minecraft.registry.RegistryKeys;
import net.minecraft.registry.RegistryWrapper;
import xyz.ibatv.nethercraft.block.ModBlocks;
import xyz.ibatv.nethercraft.block.custom.DarkWheatCropBlock;
import xyz.ibatv.nethercraft.item.ModItems;

import java.util.concurrent.CompletableFuture;

public class ModLootTableProvider extends FabricBlockLootTableProvider {
    public ModLootTableProvider(FabricDataOutput dataOutput, CompletableFuture<RegistryWrapper.WrapperLookup> registryLookup) {
        super(dataOutput, registryLookup);
    }

    @Override
    public void generate() {
        addDrop(ModBlocks.GLOWOOD_LOG);
        addDrop(ModBlocks.GLOWOOD_PLANKS);
        addDrop(ModBlocks.GLOWOOD_SAPLING);
        addDrop(ModBlocks.GLOWOOD_BOOKSHELF);
        addDrop(ModBlocks.GLOWOOD_STAIRS);
        addDrop(ModBlocks.GLOWOOD_PRESSUREPLATE);
        addDrop(ModBlocks.GLOWOOD_FENCE);
        addDrop(ModBlocks.GLOWOOD_DOOR, doorDrops(ModBlocks.GLOWOOD_DOOR));
        addDrop(ModBlocks.GLOWOOD_LADDER);
        addDrop(ModBlocks.NETHER_DIRT);
        addDrop(ModBlocks.NETHER_DIRT_FARMLAND, multipleOreDrops(ModBlocks.NETHER_DIRT_FARMLAND, Item.fromBlock(ModBlocks.NETHER_DIRT), 1, 1));

        addDrop(ModBlocks.GLOWOOD_LEAVES, leavesDrops(ModBlocks.GLOWOOD_LEAVES, ModBlocks.GLOWOOD_SAPLING, 0.0625f));

        //addDrop(ModBlocks.PROSPERITY_ORE, multipleOreDrops(ModBlocks.PROSPERITY_ORE, ModItems.PROSPERITY_SHARD, 1, 4));
        //addDrop(ModBlocks.INFERIUM_ORE, multipleOreDrops(ModBlocks.INFERIUM_ORE, ModItems.INFERIUM_ESSENCE, 2, 4));



        addDrop(ModBlocks.FOULITE_ORE, multipleOreDrops(ModBlocks.FOULITE_ORE, ModItems.FOULITE_DUST, 1, 1));
        addDrop(ModBlocks.W_ORE, multipleOreDrops(ModBlocks.W_ORE, ModItems.W_DUST, 1, 1));
        addDrop(ModBlocks.LINIUM_ORE);
        addDrop(ModBlocks.NERIDIUM_ORE);
        addDrop(ModBlocks.PYRIDIUM_ORE);

        addDrop(ModBlocks.LINIUM_BLOCK);
        addDrop(ModBlocks.NERIDIUM_BLOCK);
        addDrop(ModBlocks.PYRIDIUM_BLOCK);


        addDrop(ModBlocks.HEAT_SAND);
        addDrop(ModBlocks.GREEN_GLOWSHROOM);
        addDrop(ModBlocks.PURPLE_GLOWSHROOM);
        addDrop(ModBlocks.LAVA_REEDS);


        BlockStatePropertyLootCondition.Builder builder2 = BlockStatePropertyLootCondition.builder(ModBlocks.DARK_WHEAT_CROP)
                .properties(StatePredicate.Builder.create().exactMatch(DarkWheatCropBlock.AGE, DarkWheatCropBlock.MAX_AGE));
        this.addDrop(ModBlocks.DARK_WHEAT_CROP, this.cropDrops(ModBlocks.DARK_WHEAT_CROP, ModItems.DARK_WHEAT, ModItems.DARK_WHEAT_SEEDS, builder2));

    }
    public LootTable.Builder multipleOreDrops(Block drop, Item item, float minDrops, float maxDrops) {
        RegistryWrapper.Impl<Enchantment> impl = this.registryLookup.getWrapperOrThrow(RegistryKeys.ENCHANTMENT);
        return this.dropsWithSilkTouch(drop, this.applyExplosionDecay(drop, ((LeafEntry.Builder<?>)
                ItemEntry.builder(item).apply(SetCountLootFunction.builder(UniformLootNumberProvider.create(minDrops, maxDrops))))
                .apply(ApplyBonusLootFunction.oreDrops(impl.getOrThrow(Enchantments.FORTUNE)))));
    }

}
