package xyz.ibatv.nethercraft.item;

import net.fabricmc.fabric.api.itemgroup.v1.ItemGroupEvents;
import net.minecraft.fluid.Fluids;
import net.minecraft.item.*;
import net.minecraft.registry.Registries;
import net.minecraft.registry.Registry;
import net.minecraft.util.Identifier;
import xyz.ibatv.nethercraft.NethercraftClassic;
import xyz.ibatv.nethercraft.block.ModBlocks;

import static net.minecraft.item.Items.BUCKET;

public class ModItems {
    public static final Item NETHERSTICK = registerItem("netherstick", new Item(new Item.Settings()));
    public static final Item DARK_WHEAT = registerItem("dark_wheat", new Item(new Item.Settings()));
    public static final Item LAVA_PAPER = registerItem("lava_paper", new Item(new Item.Settings()));
    public static final Item LAVA_BOOK = registerItem("lava_book", new Item(new Item.Settings()));
    public static final Item IMP_SKIN = registerItem("imp_skin", new Item(new Item.Settings()));

    public static final Item FOULITE_DUST = registerItem("foulite_dust", new Item(new Item.Settings()));
    public static final Item W_DUST = registerItem("w_dust", new Item(new Item.Settings()));

    public static final Item LINIUM_INGOT = registerItem("linium_ingot", new Item(new Item.Settings()));
    public static final Item NERIDIUM_INGOT = registerItem("neridium_ingot", new Item(new Item.Settings()));
    public static final Item PYRIDIUM_INGOT = registerItem("pyridium_ingot", new Item(new Item.Settings()));
    public static final Item W_INGOT = registerItem("w_ingot", new Item(new Item.Settings()));


    public static final Item GLOWOOD_BOWL = registerItem("glowood_bowl", new Item(new Item.Settings()));


    public static final Item DEVILBREAD = registerItem("devilbread", new Item(new Item.Settings().food(ModFoodComponents.DEVILBREAD)));
    public static final Item GLOW_APPLE = registerItem("glow_apple", new Item(new Item.Settings().food(ModFoodComponents.GLOW_APPLE)));
    public static final Item GLOWSTEW = registerItem("glowstew", new Item(new Item.Settings().food(ModFoodComponents.GLOWSTEW)));

    public static final Item DARK_WHEAT_SEEDS = registerItem("dark_wheat_seeds",
            new AliasedBlockItem(ModBlocks.DARK_WHEAT_CROP, new Item.Settings()));


    public static final Item NERIDIUM_LIGHTER = registerItem("neridium_lighter",
            new FlintAndSteelItem(new Item.Settings().maxDamage(64)));



    // Todo: Find out a way to implement custom buckets that dont auto-magically
    //  convert back to regular minecraft:bucket. I tried BucketLib and even making a
    //  custom bucket class, but it MucketLib didnt work, and custom bucket class
    //  kept converting them back to minecraft:bucket.

    //public static final Item NERIDIUM_BUCKET = registerItem("neridium_bucket",
    //        new BucketItem(Fluids.EMPTY, (new Item.Settings()).maxCount(16)));

    //public static final Item NERIDIUM_LAVA_BUCKET = registerItem("neridium_lava_bucket",
    //        new BucketItem(Fluids.LAVA, (new Item.Settings()).recipeRemainder(BUCKET).maxCount(16)));



    public static final Item GLOWOOD_SWORD = registerItem("glowood_sword",
            new SwordItem(ModToolMaterials.GLOW_WOOD, new Item.Settings()
                    .attributeModifiers(SwordItem.createAttributeModifiers(ModToolMaterials.GLOW_WOOD, 3, -2.4f))));

    public static final Item GLOWOOD_PICKAXE = registerItem("glowood_pickaxe",
            new PickaxeItem(ModToolMaterials.GLOW_WOOD, new Item.Settings()
                    .attributeModifiers(PickaxeItem.createAttributeModifiers(ModToolMaterials.GLOW_WOOD, 1, -2.8f))));

    public static final Item GLOWOOD_SHOVEL = registerItem("glowood_shovel",
            new ShovelItem(ModToolMaterials.GLOW_WOOD, new Item.Settings()
                    .attributeModifiers(ShovelItem.createAttributeModifiers(ModToolMaterials.GLOW_WOOD, 1.5f, -3f))));

    public static final Item GLOWOOD_AXE = registerItem("glowood_axe",
            new AxeItem(ModToolMaterials.GLOW_WOOD, new Item.Settings()
                    .attributeModifiers(AxeItem.createAttributeModifiers(ModToolMaterials.GLOW_WOOD, 6, -3.2f))));

    public static final Item GLOWOOD_HOE = registerItem("glowood_hoe",
            new HoeItem(ModToolMaterials.GLOW_WOOD, new Item.Settings()
                    .attributeModifiers(HoeItem.createAttributeModifiers(ModToolMaterials.GLOW_WOOD, 0, -3f))));


    public static final Item NETHER_SWORD = registerItem("nether_sword",
            new SwordItem(ModToolMaterials.NETHERRACK, new Item.Settings()
                    .attributeModifiers(SwordItem.createAttributeModifiers(ModToolMaterials.NETHERRACK, 3, -2.4f))));

    public static final Item NETHER_PICKAXE = registerItem("nether_pickaxe",
            new PickaxeItem(ModToolMaterials.NETHERRACK, new Item.Settings()
                    .attributeModifiers(PickaxeItem.createAttributeModifiers(ModToolMaterials.NETHERRACK, 1, -2.8f))));

    public static final Item NETHER_SHOVEL = registerItem("nether_shovel",
            new ShovelItem(ModToolMaterials.NETHERRACK, new Item.Settings()
                    .attributeModifiers(ShovelItem.createAttributeModifiers(ModToolMaterials.NETHERRACK, 1.5f, -3f))));

    public static final Item NETHER_AXE = registerItem("nether_axe",
            new AxeItem(ModToolMaterials.NETHERRACK, new Item.Settings()
                    .attributeModifiers(AxeItem.createAttributeModifiers(ModToolMaterials.NETHERRACK, 6, -3.2f))));

    public static final Item NETHER_HOE = registerItem("nether_hoe",
            new HoeItem(ModToolMaterials.NETHERRACK, new Item.Settings()
                    .attributeModifiers(HoeItem.createAttributeModifiers(ModToolMaterials.NETHERRACK, 0, -3f))));


    public static final Item LINIUM_SWORD = registerItem("linium_sword",
            new SwordItem(ModToolMaterials.LINIUM, new Item.Settings()
                    .attributeModifiers(SwordItem.createAttributeModifiers(ModToolMaterials.LINIUM, 3, -2.4f))));

    public static final Item LINIUM_PICKAXE = registerItem("linium_pickaxe",
            new PickaxeItem(ModToolMaterials.LINIUM, new Item.Settings()
                    .attributeModifiers(PickaxeItem.createAttributeModifiers(ModToolMaterials.LINIUM, 1, -2.8f))));

    public static final Item LINIUM_SHOVEL = registerItem("linium_shovel",
            new ShovelItem(ModToolMaterials.LINIUM, new Item.Settings()
                    .attributeModifiers(ShovelItem.createAttributeModifiers(ModToolMaterials.LINIUM, 1.5f, -3f))));

    public static final Item LINIUM_AXE = registerItem("linium_axe",
            new AxeItem(ModToolMaterials.LINIUM, new Item.Settings()
                    .attributeModifiers(AxeItem.createAttributeModifiers(ModToolMaterials.LINIUM, 6, -3.2f))));

    public static final Item LINIUM_HOE = registerItem("linium_hoe",
            new HoeItem(ModToolMaterials.LINIUM, new Item.Settings()
                    .attributeModifiers(HoeItem.createAttributeModifiers(ModToolMaterials.LINIUM, 0, -3f))));


    public static final Item NERIDIUM_SWORD = registerItem("neridium_sword",
            new SwordItem(ModToolMaterials.NERIDIUM, new Item.Settings()
                    .attributeModifiers(SwordItem.createAttributeModifiers(ModToolMaterials.NERIDIUM, 3, -2.4f))));

    public static final Item NERIDIUM_PICKAXE = registerItem("neridium_pickaxe",
            new PickaxeItem(ModToolMaterials.NERIDIUM, new Item.Settings()
                    .attributeModifiers(PickaxeItem.createAttributeModifiers(ModToolMaterials.NERIDIUM, 1, -2.8f))));

    public static final Item NERIDIUM_SHOVEL = registerItem("neridium_shovel",
            new ShovelItem(ModToolMaterials.NERIDIUM, new Item.Settings()
                    .attributeModifiers(ShovelItem.createAttributeModifiers(ModToolMaterials.NERIDIUM, 1.5f, -3f))));

    public static final Item NERIDIUM_AXE = registerItem("neridium_axe",
            new AxeItem(ModToolMaterials.NERIDIUM, new Item.Settings()
                    .attributeModifiers(AxeItem.createAttributeModifiers(ModToolMaterials.NERIDIUM, 6, -3.2f))));

    public static final Item NERIDIUM_HOE = registerItem("neridium_hoe",
            new HoeItem(ModToolMaterials.NERIDIUM, new Item.Settings()
                    .attributeModifiers(HoeItem.createAttributeModifiers(ModToolMaterials.NERIDIUM, 0, -3f))));


    public static final Item PYRIDIUM_SWORD = registerItem("pyridium_sword",
            new SwordItem(ModToolMaterials.PYRIDIUM, new Item.Settings()
                    .attributeModifiers(SwordItem.createAttributeModifiers(ModToolMaterials.PYRIDIUM, 3, -2.4f))));

    public static final Item PYRIDIUM_PICKAXE = registerItem("pyridium_pickaxe",
            new PickaxeItem(ModToolMaterials.PYRIDIUM, new Item.Settings()
                    .attributeModifiers(PickaxeItem.createAttributeModifiers(ModToolMaterials.PYRIDIUM, 1, -2.8f))));

    public static final Item PYRIDIUM_SHOVEL = registerItem("pyridium_shovel",
            new ShovelItem(ModToolMaterials.PYRIDIUM, new Item.Settings()
                    .attributeModifiers(ShovelItem.createAttributeModifiers(ModToolMaterials.PYRIDIUM, 1.5f, -3f))));

    public static final Item PYRIDIUM_AXE = registerItem("pyridium_axe",
            new AxeItem(ModToolMaterials.PYRIDIUM, new Item.Settings()
                    .attributeModifiers(AxeItem.createAttributeModifiers(ModToolMaterials.PYRIDIUM, 6, -3.2f))));

    public static final Item PYRIDIUM_HOE = registerItem("pyridium_hoe",
            new HoeItem(ModToolMaterials.PYRIDIUM, new Item.Settings()
                    .attributeModifiers(HoeItem.createAttributeModifiers(ModToolMaterials.PYRIDIUM, 0, -3f))));


    private static Item registerItem(String name, Item item) {
        return Registry.register(Registries.ITEM, Identifier.of(NethercraftClassic.MOD_ID, name), item);
    }

    public static void registerModItems() {
        NethercraftClassic.LOGGER.info("Registering Mod Items for " + NethercraftClassic.MOD_ID);
    }
}